import { Token } from './Token';
import { add as addHook } from './hooks';
export interface TokenObject {
    pattern: RegExp;
    inside?: Map<string, TokenTypes>;
    lookbehind?: boolean;
    greedy?: boolean;
    alias?: string;
}
export declare type Tokenz = RegExp | TokenObject | Array<RegExp | TokenObject>;
export declare type TokenTypes = Tokenz | Map<string, Tokenz>;
export declare type Definition = Map<string, TokenTypes>;
export declare type Plugin = (a: typeof addHook) => void;
export declare const languages: Map<string, Map<string, TokenTypes>>;
export declare function tokenize(text: string, grammar: Definition): Array<string | Token>;
export interface HighlightEnv {
    code: string;
    highlightedCode: string;
    grammar: Definition;
    language: string;
}
export declare function highlight(text: string, language: string): string;
export declare function addPlugin(plugin: Plugin): void;
export declare function addLanguage(name: string, def: Definition): void;
export declare function getLanguage(name: string): Definition | undefined;
