"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const hooks = {};
function add(name, callback) {
    if (typeof name !== 'string' || name.length < 1) {
        throw new Error('Name must be string of length > 1');
    }
    if (typeof callback !== 'function') {
        throw new Error(`hooks.add expects a function to be passed as a callback but ${typeof callback}:${callback} given`);
    }
    if (!hooks[name])
        hooks[name] = new Set();
    hooks[name].add(callback);
}
exports.add = add;
function run(name, env) {
    const callbacks = hooks[name];
    if (!callbacks || !callbacks.size) {
        return;
    }
    callbacks.forEach(callback => callback(env));
}
exports.run = run;
