"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../utils");
const clike_1 = require("./clike");
let javascript = utils_1.clone(clike_1.clike);
exports.javascript = javascript;
javascript.set('keyword', /\b(?:as|async|await|break|case|catch|class|const|continue|debugger|default|delete|do|else|enum|export|extends|finally|for|from|function|get|if|implements|import|in|instanceof|interface|let|new|null|of|package|private|protected|public|return|set|static|super|switch|this|throw|try|typeof|var|void|while|with|yield)\b/);
javascript.set('number', /\b-?(?:0[xX][\dA-Fa-f]+|0[bB][01]+|0[oO][0-7]+|\d*\.?\d+(?:[Ee][+-]?\d+)?|NaN|Infinity)\b/);
// Allow for all non-ASCII characters (See http://stackoverflow.com/a/2008444)
javascript.set('function', /[_$a-z\xA0-\uFFFF][$\w\xA0-\uFFFF]*(?=\s*\()/i);
javascript.set('operator', /-[-=]?|\+[+=]?|!=?=?|<<?=?|>>?>?=?|=(?:==?|>)?|&[&=]?|\|[|=]?|\*\*?=?|\/=?|~|\^=?|%=?|\?|\.{3}/);
utils_1.insertBefore(javascript, 'keyword', new Map([
    [
        'regex',
        {
            pattern: /(^|[^/])\/(?!\/)(\[[^\]\r\n]+]|\\.|[^/\\\[\r\n])+\/[gimyu]{0,5}(?=\s*($|[\r\n,.;})]))/,
            lookbehind: true,
            greedy: true
        }
    ],
    [
        'function-variable',
        {
            pattern: /[_$a-z\xA0-\uFFFF][$\w\xA0-\uFFFF]*(?=\s*=\s*(?:function\b|(?:\([^()]*\)|[_$a-z\xA0-\uFFFF][$\w\xA0-\uFFFF]*)\s*=>))/i,
            alias: 'function'
        }
    ]
]));
const extendDef = utils_1.clone(javascript);
utils_1.insertBefore(javascript, 'class-name', new Map([
    [
        'template-string',
        {
            pattern: /`(?:\\[\s\S]|[^\\`])*`/,
            greedy: true,
            inside: new Map([
                [
                    'interpolation',
                    {
                        pattern: /\$\{[^}]+\}/,
                        inside: new Map([
                            [
                                'interpolation-punctuation',
                                {
                                    pattern: /^\$\{|\}$/,
                                    alias: 'punctuation'
                                }
                            ],
                            ['rest', extendDef]
                        ])
                    }
                ],
                ['string', /[\s\S]+/]
            ])
        }
    ]
]));
