"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const javascript_1 = require("./javascript");
const markup_1 = require("./markup");
// import { clone, setIn, insertBefore } from '../utils';
const utils_1 = require("../utils");
let jsx = utils_1.clone(markup_1.markup);
exports.jsx = jsx;
javascript_1.javascript.forEach((value, key) => jsx.set(key, value));
utils_1.setIn(jsx, ['tag', 'pattern'], /<\/?[\w.:-]+\s*(?:\s+(?:[\w.:-]+(?:=(?:("|')(?:\\[\s\S]|(?!\1)[^\\])*\1|[^\s'">=]+|(?:\{\{?[^}]*\}?\})))?|\{\.{3}[a-z_$][\w$]*(?:\.[a-z_$][\w$]*)*\}))*\s*\/?>/i);
utils_1.setIn(jsx, ['tag', 'inside', 'attr-value', 'pattern'], /=(?!\{)(?:("|')(?:\\[\s\S]|(?!\1)[^\\])*\1|[^\s'">]+)/i);
utils_1.insertBefore(utils_1.getIn(jsx, ['tag', 'inside']), 'attr-name', new Map([
    [
        'spread',
        {
            pattern: /\{\.{3}[a-z_$][\w$]*(?:\.[a-z_$][\w$]*)*\}/,
            inside: new Map([['punctuation', /\.{3}|[{}.]/], ['attr-value', /\w+/]])
        }
    ]
]));
let jsxExpression = utils_1.clone(jsx);
jsxExpression.delete('punctuation');
jsxExpression = utils_1.insertBefore(jsxExpression, 'operator', new Map([['punctuation', /=(?={)|[{}[\];(),.:]/]]));
utils_1.insertBefore(utils_1.getIn(jsx, ['tag', 'inside']), 'attr-value', new Map([
    [
        'script',
        {
            // Allow for one level of nesting
            pattern: /=(\{(?:\{[^}]*\}|[^}])+\})/i,
            inside: jsxExpression,
            alias: 'language-javascript'
        }
    ]
]));
