"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const clike_1 = require("./clike");
const utils_1 = require("../utils");
const php = utils_1.clone(clike_1.clike);
exports.php = php;
php.set('string', {
    pattern: /(["'])(?:\\[\s\S]|(?!\1)[^\\])*\1/,
    greedy: true
});
php.set('keyword', /\b(?:and|or|xor|array|as|break|case|cfunction|class|const|continue|declare|default|die|do|else|elseif|enddeclare|endfor|endforeach|endif|endswitch|endwhile|extends|for|foreach|function|include|include_once|global|if|new|return|static|switch|use|require|require_once|var|while|abstract|interface|public|implements|private|protected|parent|throw|null|echo|print|trait|namespace|final|yield|goto|instanceof|finally|try|catch)\b/i);
php.set('constant', /\b[A-Z0-9_]{2,}\b/);
php.set('comment', {
    pattern: /(^|[^\\])(?:\/\*[\s\S]*?\*\/|\/\/.*)/,
    lookbehind: true
});
// Shell-like comments are matched after strings, because they are less
// common than strings containing hashes...
utils_1.insertBefore(php, 'class-name', new Map([
    [
        'shell-comment',
        {
            pattern: /(^|[^\\])#.*/,
            lookbehind: true,
            alias: 'comment'
        }
    ]
]));
utils_1.insertBefore(php, 'keyword', new Map([
    [
        'delimiter',
        {
            pattern: /\?>|<\?(?:php|=)?/i,
            alias: 'important'
        }
    ],
    ['variable', /\$\w+\b/i],
    [
        'package',
        {
            pattern: /(\\|namespace\s+|use\s+)[\w\\]+/,
            lookbehind: true,
            inside: new Map([['punctuation', /\\/]])
        }
    ]
]));
// Must be defined after the function pattern
utils_1.insertBefore(php, 'operator', new Map([
    [
        'property',
        {
            pattern: /(->)[\w]+/,
            lookbehind: true
        }
    ]
]));
utils_1.insertBefore(php, 'variable', new Map([
    ['this', /\$this\b/],
    [
        'global',
        /\$(?:_(?:SERVER|GET|POST|FILES|REQUEST|SESSION|ENV|COOKIE)|GLOBALS|HTTP_RAW_POST_DATA|argc|argv|php_errormsg|http_response_header)\b/
    ],
    [
        'scope',
        {
            pattern: /\b[\w\\]+::/,
            inside: new Map([['keyword', /static|self|parent/], ['punctuation', /::|\\/]])
        }
    ]
]));
